﻿Option Strict On
Imports Microsoft.Phone.Notification
Imports System.IO
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        Dim myPushChannel As HttpNotificationChannel
        Dim myChannelName As String = "KySS_RawChannel"

        myPushChannel = HttpNotificationChannel.Find(myChannelName)

        If myPushChannel Is Nothing = True Then
            myPushChannel = New HttpNotificationChannel(myChannelName)
            AddHandler myPushChannel.ChannelUriUpdated, AddressOf PushChannel_ChannelUriUpdated
            AddHandler myPushChannel.ErrorOccurred, AddressOf PushChannel_ErrorOccurred
            AddHandler myPushChannel.HttpNotificationReceived, AddressOf PushChannel_HttpNotificationReceived

            myPushChannel.Open()
        Else
            AddHandler myPushChannel.ChannelUriUpdated, AddressOf PushChannel_ChannelUriUpdated
            AddHandler myPushChannel.ErrorOccurred, AddressOf PushChannel_ErrorOccurred
            AddHandler myPushChannel.HttpNotificationReceived, AddressOf PushChannel_HttpNotificationReceived
            'System.Diagnostics.Debug.WriteLine(myPushChannel.ChannelUri.ToString())
            MessageBox.Show(String.Format("チャネルURI={0}", myPushChannel.ChannelUri.ToString()))
            SendUriToServer(myPushChannel.ChannelUri.ToString())
        End If

    End Sub

    Private Sub PushChannel_ChannelUriUpdated(sender As Object, e As NotificationChannelUriEventArgs)
        Dispatcher.BeginInvoke(Sub()
                                   'System.Diagnostics.Debug.WriteLine(e.ChannelUri.ToString())
                                   MessageBox.Show(String.Format("チャネルURI={0}", e.ChannelUri.ToString()))
                                   SendUriToServer(e.ChannelUri.ToString())
                               End Sub)
    End Sub

    Private Sub PushChannel_ErrorOccurred(sender As Object, e As NotificationChannelErrorEventArgs)
        Dispatcher.BeginInvoke(Sub()
                                   MessageBox.Show(String.Format("プッシュ通知{0}エラー発生!{1}{2}{3}", e.ErrorType, e.Message, e.ErrorCode, e.ErrorAdditionalData))
                               End Sub)
    End Sub

    Private Sub PushChannel_HttpNotificationReceived(sender As Object, e As HttpNotificationEventArgs)
        Dim myMessage As String = String.Empty

        Dim myReader As StreamReader = New StreamReader(e.Notification.Body)
        myMessage = myReader.ReadToEnd
        myReader.Close()
        Dispatcher.BeginInvoke(Sub()
                                   MessageBox.Show(String.Format("通知受信{0}{1}{2}", DateTime.Now.ToShortTimeString, vbCrLf, myMessage))
                               End Sub)
    End Sub

    Private Sub SendUriToServer(myChannelUri As String)

        Dim myWebClient As New WebClient
        With myWebClient
            .Encoding = System.Text.Encoding.UTF8
            .Headers("content-type") = "application/x-www-form-urlencoded"
            '.Credentials = New NetworkCredential("Administrator", "Danke!DJ+2E(k&s)")
        End With

        AddHandler myWebClient.UploadStringCompleted, Sub(uploadSender As Object, uploadE As UploadStringCompletedEventArgs)
                                                          MessageBox.Show(uploadE.Result)
                                                      End Sub

        '「あなたのサーバーのURI」にTileNotification_NETをアップロードしたサーバーのURIを指定してください。
        myWebClient.UploadStringAsync(New Uri("あなたのサーバーのURI/TileNotification_NET/Default.aspx", UriKind.Absolute), myChannelUri)
    End Sub

End Class
